Require Import bool.
Require Import connectives.
Require Import div_mod.
Require Import leibniz.
Require Import logic.
Require Import nat.
Require Import primes.
Parameter gcd_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter gcd_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_gcd_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p).
Definition eq_gcd_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p)) ((axiom_gcd_aux) (p)).
Definition sym_eq_gcd_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p) (gcd_aux p) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p)) ((eq_gcd_aux) (p)).
Axiom axiom_gcd_aux_body_O : connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m).
Definition eq_gcd_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m) := ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (axiom_gcd_aux_body_O).
Axiom axiom_gcd_aux_body_S : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)).
Definition eq_gcd_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body (nat.S p)) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m))) ((axiom_gcd_aux_body_S) (p)).
Definition sym_eq_gcd_aux_body_S : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m)) (gcd_aux_body (nat.S p)) := fun (p:nat.nat) => ((((leibniz.sym_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body (nat.S p))) (fun (m:nat.nat) => fun (n:nat.nat) => bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) (primes.dividesb n m))) ((eq_gcd_aux_body_S) (p)).
Definition gcd : nat.nat -> nat.nat -> nat.nat := fun (n:nat.nat) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) (nat.leb n m).
Definition commutative_gcd : forall (n:nat.nat), forall (m:nat.nat), logic.eq (nat.nat) (gcd n m) (gcd m n) := fun (n:nat.nat) => fun (m:nat.nat) => (((((nat.leb_elim) (n)) (m)) (fun (__:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) __) (bool.match_bool_type (nat.nat) (gcd_aux m n m) (gcd_aux n m n) (nat.leb m n)))) (fun (lenm:nat.le n m) => (((((((connectives.match_Or_prop) (nat.lt n m)) (logic.eq (nat.nat) n m)) (logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true) (bool.match_bool_type (nat.nat) (gcd_aux m n m) (gcd_aux n m n) (nat.leb m n)))) (fun (ltnm:nat.lt n m) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true) (bool.match_bool_type (nat.nat) (gcd_aux m n m) (gcd_aux n m n) x))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (gcd_aux m n m)) (gcd_aux n m n)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true) y)) ((((((bool.eq_match_bool_type_true) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true))))) (nat.leb m n)) ((((nat.not_le_to_leb_false) (m)) (n)) ((((nat.lt_to_not_le) (n)) (m)) (ltnm)))))) (fun (eqnm:logic.eq (nat.nat) n m) => (((((((logic.eq_ind_r) (nat.nat)) (m)) (fun (x:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux x m x) (gcd_aux m x m) bool.true) (bool.match_bool_type (nat.nat) (gcd_aux m x m) (gcd_aux x m x) (nat.leb m x)))) (((((bool.match_bool_prop) (fun (__:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) bool.true) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) __))) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) bool.true))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (gcd_aux m m m)) (gcd_aux m m m)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) bool.true) y)) ((((((bool.eq_match_bool_type_true) (nat.nat)) (gcd_aux m m m)) (gcd_aux m m m)) (fun (y:nat.nat) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) bool.true) y)) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (gcd_aux m m m) (gcd_aux m m m) bool.true))))) (nat.leb m m))) (n)) (eqnm)))) ((((nat.le_to_or_lt_eq) (n)) (m)) (lenm))))) (fun (notlenm:connectives.Not (nat.le n m)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.false) (bool.match_bool_type (nat.nat) (gcd_aux m n m) (gcd_aux n m n) x))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => logic.eq (nat.nat) y (bool.match_bool_type (nat.nat) (gcd_aux m n m) (gcd_aux n m n) bool.true))) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (gcd_aux m n m)) (gcd_aux n m n)) (fun (y:nat.nat) => logic.eq (nat.nat) (gcd_aux m n m) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => logic.eq (nat.nat) (gcd_aux m n m) y)) ((((((bool.eq_match_bool_type_false) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => logic.eq (nat.nat) y (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.false))) (((logic.refl) (nat.nat)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.false))))))) (nat.leb m n)) ((((nat.le_to_leb_true) (m)) (n)) ((((((nat.transitive_le) (m)) (nat.S m)) (n)) ((nat.le_n_Sn) (m))) ((((nat.not_le_to_lt) (n)) (m)) (notlenm)))))).
Definition gcd_O_l : forall (m:nat.nat), logic.eq (nat.nat) (gcd nat.O m) m := fun (m:nat.nat) => (((((bool.eq_match_bool_type_true) (nat.nat)) (m)) (gcd_aux m nat.O m)) (fun (y:nat.nat) => logic.eq (nat.nat) (gcd nat.O m) y)) (((nat.eq_leb_body_O) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) (((((nat.eq_filter_nat_type_O) (nat.nat -> bool.bool)) (nat.leb_body)) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) ((((nat.eq_leb) (nat.O)) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) (((eq_gcd_aux_body_O) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) (((((nat.eq_filter_nat_type_O) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) ((((eq_gcd_aux) (nat.O)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) (((logic.refl) (nat.nat)) (gcd nat.O m)))))))).
Definition divides_to_gcd_aux : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O p) -> (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (gcd_aux p m n) n := fun (p:nat.nat) => fun (m:nat.nat) => fun (n:nat.nat) => fun (posp:nat.lt nat.O p) => (((((nat.lt_O_n_elim) (p)) (posp)) (fun (__:nat.nat) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (gcd_aux __ m n) n)) (fun (l:nat.nat) => (((sym_eq_gcd_aux) (nat.S l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) ((((sym_eq_gcd_aux_body_S) (l)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (primes.divides n m) -> logic.eq (nat.nat) (y m n) n)) (fun (posn:nat.lt nat.O n) => (fun (divnm:primes.divides n m) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) n (gcd_aux l n (div_mod.mod m n)) x) n)) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (n)) (gcd_aux l n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))) (fun (y:nat.nat) => logic.eq (nat.nat) y n)) (((logic.refl) (nat.nat)) (n)))) (primes.dividesb n m)) (((((primes.divides_to_dividesb_true) (n)) (m)) (posn)) (divnm))))))))).
Definition not_divides_to_gcd_aux : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (gcd_aux (nat.S p) m n) (gcd_aux p n (div_mod.mod m n)) := fun (p:nat.nat) => fun (m:nat.nat) => fun (n:nat.nat) => (((sym_eq_gcd_aux) (nat.S p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) ((((((nat.sym_eq_filter_nat_type_S) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) ((((sym_eq_gcd_aux_body_S) (p)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => (nat.lt nat.O n) -> (connectives.Not (primes.divides n m)) -> logic.eq (nat.nat) (y m n) (gcd_aux p n (div_mod.mod m n)))) (fun (lenm:nat.lt nat.O n) => (fun (divnm:connectives.Not (primes.divides n m)) => (((((((logic.eq_ind_r) (bool.bool)) (bool.false)) (fun (x:bool.bool) => logic.eq (nat.nat) (bool.match_bool_type (nat.nat) n (gcd_aux p n (div_mod.mod m n)) x) (gcd_aux p n (div_mod.mod m n)))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (n)) (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))) (fun (y:nat.nat) => logic.eq (nat.nat) y (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n)))) (((logic.refl) (nat.nat)) (gcd_aux p n (nat.match_nat_type (nat.nat) m (fun (p0:nat.nat) => div_mod.mod_aux m m p0) n))))) (primes.dividesb n m)) (((((primes.not_divides_to_dividesb_false) (n)) (m)) (lenm)) (divnm))))))).
Definition let_clause_1544 : forall (p:nat.nat), forall (q:nat.nat), (forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q m n))))) -> forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n (nat.S q)) -> (connectives.Not (primes.divides n m)) -> forall (a:nat.nat), (connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) -> forall (b:nat.nat), (connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) -> (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) -> logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times n b)) (gcd_aux q n (div_mod.mod m n)) := fun (p:nat.nat) => fun (q:nat.nat) => fun (Hind:forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q m n))))) => (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenS:nat.le n (nat.S q)) => (fun (ndivnm:connectives.Not (primes.divides n m)) => (fun (a:nat.nat) => fun (_clearme:connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) => (fun (b:nat.nat) => fun (_clearme0:connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) => (fun (H:logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) => (((((((logic.rewrite_l) (nat.nat)) (nat.times b n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) __) (gcd_aux q n (div_mod.mod m n)))) (H)) (nat.times n b)) (((nat.commutative_times) (b)) (n)))))))))).
Definition let_clause_15441 : forall (p:nat.nat), forall (q:nat.nat), (forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q m n))))) -> forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n (nat.S q)) -> (connectives.Not (primes.divides n m)) -> forall (a:nat.nat), (connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) -> forall (b:nat.nat), (connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) -> (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))) -> logic.eq (nat.nat) (nat.minus (nat.times n b) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)) := fun (p:nat.nat) => fun (q:nat.nat) => fun (Hind:forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q m n))))) => (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenS:nat.le n (nat.S q)) => (fun (ndivnm:connectives.Not (primes.divides n m)) => (fun (a:nat.nat) => fun (_clearme:connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) => (fun (b:nat.nat) => fun (_clearme0:connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) => (fun (H:logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))) => (((((((logic.rewrite_l) (nat.nat)) (nat.times b n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) (H)) (nat.times n b)) (((nat.commutative_times) (b)) (n)))))))))).
Definition eq_minus_gcd_aux : forall (p:nat.nat), forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n p) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux p m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux p m n)))) := fun (p:nat.nat) => ((((nat.nat_ind) (fun (_x_365:nat.nat) => forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n _x_365) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux _x_365 m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux _x_365 m n)))))) (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenO:nat.le n nat.O) => (((connectives.falsity) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux nat.O m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux nat.O m n)))))) ((((logic.absurd) (nat.lt nat.O n)) (posn)) ((((nat.le_to_not_lt) (n)) (nat.O)) (lenO)))))))) (fun (q:nat.nat) => fun (Hind:forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (nat.le n m) -> (nat.le n q) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q m n))))) => (fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (lenm:nat.le n m) => (fun (lenS:nat.le n (nat.S q)) => (((((((connectives.match_Or_prop) (primes.divides n m)) (connectives.Not (primes.divides n m))) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux (nat.S q) m n)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux (nat.S q) m n)))))) (fun (divnm:primes.divides n m) => (((((((logic.eq_ind_r) (nat.nat)) (n)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) x) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) x))))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b m)) n) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times x n)) n)))) (nat.S nat.O)) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times x m)) n) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times (nat.S nat.O) n)) n))) (nat.O)) ((((connectives.or_introl) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times nat.O m)) n)) (logic.eq (nat.nat) (nat.minus (nat.times nat.O m) (nat.times (nat.S nat.O) n)) n)) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.S nat.O))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) n)) (((((((logic.rewrite_l) (nat.nat)) (nat.plus n (nat.times n nat.O))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus n __) (nat.times nat.O m)) n)) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) n)) (((((((logic.rewrite_r) (nat.nat)) (nat.times m nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus n __) n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus n __) n)) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (nat.nat) __ n)) (((logic.refl) (nat.nat)) (n))) (nat.minus n nat.O)) ((nat.minus_n_O) (n)))) (nat.times m nat.O)) ((nat.times_n_O) (m)))) (nat.times nat.O m)) (((nat.commutative_times) (nat.O)) (m)))) (nat.plus n nat.O)) ((nat.plus_n_O) (n)))) (nat.times n nat.O)) ((nat.times_n_O) (n)))) (nat.times n (nat.S nat.O))) (((nat.times_n_Sm) (n)) (nat.O)))) (nat.times (nat.S nat.O) n)) (((nat.commutative_times) (nat.S nat.O)) (n))))))) (gcd_aux (nat.S q) m n)) (((((((divides_to_gcd_aux) (nat.S q)) (m)) (n)) ((nat.lt_O_S) (q))) (posn)) (divnm))))) (fun (ndivnm:connectives.Not (primes.divides n m)) => (((((((logic.eq_ind_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) x) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) x))))) ((((((connectives.match_ex_prop) (nat.nat)) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))))) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux q n (div_mod.mod m n))))))) (fun (a:nat.nat) => fun (_clearme:connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))))) (connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b m)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a0 n)) (gcd_aux q n (div_mod.mod m n))))))) (fun (b:nat.nat) => fun (_clearme0:connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) => (((((((connectives.match_Or_prop) (logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n)))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n)))) (connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b0 m)) (gcd_aux q n (div_mod.mod m n))) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times a0 n)) (gcd_aux q n (div_mod.mod m n))))))) (fun (H:logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)) (gcd_aux q n (div_mod.mod m n))) => (((((((logic.eq_ind) (nat.nat)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n))) (fun (x_1:nat.nat) => connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b0 m)) x_1) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times a0 n)) x_1))))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b0 m)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n))) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times x n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))))) (nat.plus b (nat.times a (div_mod.div m n)))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n) (nat.times x m)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n))) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n))))) (a)) ((((connectives.or_intror) (logic.eq (nat.nat) (nat.minus (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n) (nat.times a m)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (nat.times a (div_mod.div m n)) b)) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times x_1 n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times (nat.times a (div_mod.div m n)) n) (nat.times b n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a m) x) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times (div_mod.div m n) n) (div_mod.mod m n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a x) (nat.plus (nat.times (nat.times a (div_mod.div m n)) n) (nat.times b n))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind_r) (nat.nat)) (nat.times a (nat.times (div_mod.div m n) n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a (nat.plus (nat.times (div_mod.div m n) n) (div_mod.mod m n))) (nat.plus x (nat.times b n))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (div_mod.mod m n) (nat.times (div_mod.div m n) n))) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a x_1) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times b n))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times a (div_mod.mod m n)) (nat.times a (nat.times (div_mod.div m n) n)))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus x (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times b n))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind) (nat.nat)) (nat.minus (nat.minus (nat.plus (nat.times a (div_mod.mod m n)) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n))) (fun (x_1:nat.nat) => logic.eq (nat.nat) x_1 (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (div_mod.mod m n)))) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.minus x_1 (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (nat.minus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n)))) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus x_1 (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (div_mod.div m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times a __) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.times a (div_mod.div m n)))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus __ (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (div_mod.div m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times n (nat.times a (div_mod.div m n))) (nat.times a __)) (nat.times a (div_mod.mod m n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.times a (div_mod.div m n)))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times n (nat.times a (div_mod.div m n))) __) (nat.times a (div_mod.mod m n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus __ (nat.times a (div_mod.mod m n))) (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_l) (nat.nat)) (nat.times a (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times b n)) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times a (div_mod.mod m n)) __) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.minus (nat.times a (div_mod.mod m n)) (nat.times b n)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd_aux q n (div_mod.mod m n)) (nat.minus (nat.times a (div_mod.mod m n)) __))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd_aux q n (div_mod.mod m n)) __)) (((logic.refl) (nat.nat)) (gcd_aux q n (div_mod.mod m n)))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times n b))) (((((((((((((((let_clause_1544) (p)) (q)) (Hind)) (m)) (n)) (posn)) (lenm)) (lenS)) (ndivnm)) (a)) (_clearme)) (b)) (_clearme0)) (H)))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))) (nat.minus (nat.times a (div_mod.mod m n)) (nat.times n b))) (((((((((((((((let_clause_1544) (p)) (q)) (Hind)) (m)) (n)) (posn)) (lenm)) (lenS)) (ndivnm)) (a)) (_clearme)) (b)) (_clearme0)) (H)))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))) (nat.plus nat.O (nat.times a (div_mod.mod m n)))) ((nat.plus_O_n) (nat.times a (div_mod.mod m n))))) (nat.minus (nat.times n (nat.times a (div_mod.div m n))) (nat.times n (nat.times a (div_mod.div m n))))) ((nat.minus_n_n) (nat.times n (nat.times a (div_mod.div m n)))))) (nat.times a (nat.times n (div_mod.div m n)))) ((((nat.times_times) (a)) (n)) (div_mod.div m n)))) (nat.times (div_mod.div m n) n)) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.times a (nat.times n (div_mod.div m n)))) ((((nat.times_times) (a)) (n)) (div_mod.div m n)))) (nat.times (div_mod.div m n) n)) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.minus (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (div_mod.mod m n))) (nat.times a (nat.times (div_mod.div m n) n)))) (((((nat.plus_minus) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))) ((nat.le_n) (nat.times a (nat.times (div_mod.div m n) n)))))) (nat.plus (nat.times a (div_mod.mod m n)) (nat.times a (nat.times (div_mod.div m n) n)))) (((nat.commutative_plus) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))))) (nat.minus (nat.plus (nat.times a (div_mod.mod m n)) (nat.times a (nat.times (div_mod.div m n) n))) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times b n)))) ((((nat.minus_plus) (nat.plus (nat.times a (div_mod.mod m n)) (nat.times a (nat.times (div_mod.div m n) n)))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)))) (nat.times a (nat.plus (div_mod.mod m n) (nat.times (div_mod.div m n) n)))) ((((nat.distributive_times_plus) (a)) (div_mod.mod m n)) (nat.times (div_mod.div m n) n)))) (nat.plus (nat.times (div_mod.div m n) n) (div_mod.mod m n))) (((nat.commutative_plus) (div_mod.mod m n)) (nat.times (div_mod.div m n) n)))) (nat.times (nat.times a (div_mod.div m n)) n)) ((((nat.associative_times) (a)) (div_mod.div m n)) (n)))) (m)) (((div_mod.div_mod) (m)) (n)))) (nat.times (nat.plus (nat.times a (div_mod.div m n)) b) n)) ((((nat.distributive_times_plus_r) (n)) (nat.times a (div_mod.div m n))) (b)))) (nat.plus b (nat.times a (div_mod.div m n)))) (((nat.commutative_plus) (nat.times a (div_mod.div m n))) (b))))))) (gcd_aux q n (div_mod.mod m n))) (H)))) (fun (H:logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))) (gcd_aux q n (div_mod.mod m n))) => (((((((logic.eq_ind) (nat.nat)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n)))) (fun (x_1:nat.nat) => connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b0 m)) x_1) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times a0 n)) x_1))))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b0 m)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n)))) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times x n)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))))) (nat.plus b (nat.times a (div_mod.div m n)))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n) (nat.times x m)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n)))) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n)))))) (a)) ((((connectives.or_introl) (logic.eq (nat.nat) (nat.minus (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n) (nat.times a m)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times b n) (nat.times (nat.times a (div_mod.div m n)) n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus x (nat.times a m)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times (div_mod.div m n) n) (div_mod.mod m n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.times b n) (nat.times (nat.times a (div_mod.div m n)) n)) (nat.times a x)) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (div_mod.mod m n)))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.times b n) (nat.times (nat.times a (div_mod.div m n)) n)) x) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind_r) (nat.nat)) (nat.times a (nat.times (div_mod.div m n) n))) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.times b n) x) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (div_mod.mod m n)))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind) (nat.nat)) (nat.minus (nat.minus (nat.plus (nat.times b n) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n)))) (fun (x_1:nat.nat) => logic.eq (nat.nat) x_1 (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times b n))) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.minus x_1 (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.eq_ind) (nat.nat)) (nat.plus (nat.minus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n))) (fun (x_1:nat.nat) => logic.eq (nat.nat) (nat.minus x_1 (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (div_mod.div m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times a __) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.times a (div_mod.div m n)))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus __ (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (div_mod.div m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times n (nat.times a (div_mod.div m n))) (nat.times a __)) (nat.times b n)) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.times a (div_mod.div m n)))) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus (nat.minus (nat.times n (nat.times a (div_mod.div m n))) __) (nat.times b n)) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus __ (nat.times b n)) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.plus nat.O __) (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_l) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times a (div_mod.mod m n))) (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.minus (nat.times b n) (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd_aux q n (div_mod.mod m n)) (nat.minus __ (nat.times a (div_mod.mod m n))))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux q n (div_mod.mod m n))) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd_aux q n (div_mod.mod m n)) __)) (((logic.refl) (nat.nat)) (gcd_aux q n (div_mod.mod m n)))) (nat.minus (nat.times n b) (nat.times a (div_mod.mod m n)))) (((((((((((((((let_clause_15441) (p)) (q)) (Hind)) (m)) (n)) (posn)) (lenm)) (lenS)) (ndivnm)) (a)) (_clearme)) (b)) (_clearme0)) (H)))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))) (nat.minus (nat.times n b) (nat.times a (div_mod.mod m n)))) (((((((((((((((let_clause_15441) (p)) (q)) (Hind)) (m)) (n)) (posn)) (lenm)) (lenS)) (ndivnm)) (a)) (_clearme)) (b)) (_clearme0)) (H)))) (nat.plus nat.O (nat.times n b))) ((nat.plus_O_n) (nat.times n b)))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))) (nat.minus (nat.times n (nat.times a (div_mod.div m n))) (nat.times n (nat.times a (div_mod.div m n))))) ((nat.minus_n_n) (nat.times n (nat.times a (div_mod.div m n)))))) (nat.times a (nat.times n (div_mod.div m n)))) ((((nat.times_times) (a)) (n)) (div_mod.div m n)))) (nat.times (div_mod.div m n) n)) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.times a (nat.times n (div_mod.div m n)))) ((((nat.times_times) (a)) (n)) (div_mod.div m n)))) (nat.times (div_mod.div m n) n)) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.minus (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times b n)) (nat.times a (nat.times (div_mod.div m n) n)))) (((((nat.plus_minus) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)) ((nat.le_n) (nat.times a (nat.times (div_mod.div m n) n)))))) (nat.plus (nat.times b n) (nat.times a (nat.times (div_mod.div m n) n)))) (((nat.commutative_plus) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times b n)))) (nat.minus (nat.plus (nat.times b n) (nat.times a (nat.times (div_mod.div m n) n))) (nat.plus (nat.times a (nat.times (div_mod.div m n) n)) (nat.times a (div_mod.mod m n))))) ((((nat.minus_plus) (nat.plus (nat.times b n) (nat.times a (nat.times (div_mod.div m n) n)))) (nat.times a (nat.times (div_mod.div m n) n))) (nat.times a (div_mod.mod m n))))) (nat.times (nat.times a (div_mod.div m n)) n)) ((((nat.associative_times) (a)) (div_mod.div m n)) (n)))) (nat.times a (nat.plus (nat.times (div_mod.div m n) n) (div_mod.mod m n)))) ((((nat.distributive_times_plus) (a)) (nat.times (div_mod.div m n) n)) (div_mod.mod m n)))) (m)) (((div_mod.div_mod) (m)) (n)))) (nat.times (nat.plus b (nat.times a (div_mod.div m n))) n)) ((((nat.distributive_times_plus_r) (n)) (b)) (nat.times a (div_mod.div m n)))))))) (gcd_aux q n (div_mod.mod m n))) (H)))) (_clearme0)))) (_clearme)))) ((((((Hind) (n)) (div_mod.mod m n)) (((((((connectives.match_Or_prop) (nat.lt nat.O (div_mod.mod m n))) (logic.eq (nat.nat) nat.O (div_mod.mod m n))) (nat.lt nat.O (div_mod.mod m n))) (fun (auto:nat.lt nat.O (div_mod.mod m n)) => (auto))) (fun (modO:logic.eq (nat.nat) nat.O (div_mod.mod m n)) => (((connectives.falsity) (nat.lt nat.O (div_mod.mod m n))) ((((logic.absurd) (primes.divides n m)) (((((primes.mod_O_to_divides) (n)) (m)) (posn)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) __ nat.O)) (((logic.refl) (nat.nat)) (nat.O))) (div_mod.mod m n)) (modO)))) (ndivnm))))) ((((nat.le_to_or_lt_eq) (nat.O)) (div_mod.mod m n)) ((nat.le_O_n) (div_mod.mod m n))))) ((((nat.lt_to_le) (div_mod.mod m n)) (n)) ((((div_mod.lt_mod_m_m) (m)) (n)) (posn)))) ((((nat.le_S_S_to_le) (div_mod.mod m n)) (q)) ((((((nat.transitive_le) (nat.S (div_mod.mod m n))) (n)) (nat.S q)) ((((div_mod.lt_mod_m_m) (m)) (n)) (posn))) (lenS)))))) (gcd_aux (nat.S q) m n)) ((((((not_divides_to_gcd_aux) (q)) (m)) (n)) (posn)) (ndivnm))))) (((primes.decidable_divides) (n)) (m)))))))) (p).
Definition let_clause_1549 : forall (m:nat.nat), forall (n:nat.nat), (nat.lt nat.O n) -> (logic.eq (nat.nat) nat.O m) -> forall (x1106:nat.nat), logic.eq (nat.nat) x1106 (nat.minus x1106 m) := fun (m:nat.nat) => fun (n:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (eqm0:logic.eq (nat.nat) nat.O m) => (fun (x1106:nat.nat) => ((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) x1106 (nat.minus x1106 __))) ((nat.minus_n_O) (x1106))) (m)) (eqm0))).
Definition let_clause_15491 : forall (m:nat.nat), forall (n:nat.nat), (logic.eq (nat.nat) nat.O n) -> forall (x1106:nat.nat), logic.eq (nat.nat) x1106 (nat.minus x1106 n) := fun (m:nat.nat) => fun (n:nat.nat) => fun (eqn0:logic.eq (nat.nat) nat.O n) => (fun (x1106:nat.nat) => ((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) x1106 (nat.minus x1106 __))) ((nat.minus_n_O) (x1106))) (n)) (eqn0)).
Definition let_clause_1551 : forall (m:nat.nat), forall (n:nat.nat), (logic.eq (nat.nat) nat.O n) -> forall (x347:nat.nat), logic.eq (nat.nat) n (nat.times x347 n) := fun (m:nat.nat) => fun (n:nat.nat) => fun (eqn0:logic.eq (nat.nat) nat.O n) => (fun (x347:nat.nat) => ((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) n (nat.times x347 __))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.times x347 nat.O))) ((nat.times_n_O) (x347))) (n)) (eqn0))) (n)) (eqn0)).
Definition eq_minus_gcd : forall (m:nat.nat), forall (n:nat.nat), connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd n m)))) := fun (m:nat.nat) => fun (n:nat.nat) => ((((((connectives.match_Or_prop) (nat.lt nat.O n)) (logic.eq (nat.nat) nat.O n)) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd n m)))))) (fun (posn:nat.lt nat.O n) => (((((((connectives.match_Or_prop) (nat.lt nat.O m)) (logic.eq (nat.nat) nat.O m)) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd n m)))))) (fun (posm:nat.lt nat.O m) => ((((((nat.leb_elim) (n)) (m)) (fun (__:bool.bool) => connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) __)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) __)))))) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => (nat.le n m) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.true)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) y))))) ((((((bool.sym_eq_match_bool_type_true) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => (nat.le n m) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) y) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux n m n)))))) (fun (lenm:nat.le n m) => (((((((eq_minus_gcd_aux) (n)) (m)) (n)) (posn)) (lenm)) ((nat.le_n) (n))))))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => (connectives.Not (nat.le n m)) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) bool.false)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) y))))) ((((((bool.sym_eq_match_bool_type_false) (nat.nat)) (gcd_aux n m n)) (gcd_aux m n m)) (fun (y:nat.nat) => (connectives.Not (nat.le n m)) -> connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) y) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux m n m)))))) (fun (nlenm:connectives.Not (nat.le n m)) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m))))) (connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd_aux m n m)))))) (fun (a:nat.nat) => fun (_clearme:connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m)))) => ((((((connectives.match_ex_prop) (nat.nat)) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m)))) (connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a0 n)) (gcd_aux m n m)))))) (fun (b:nat.nat) => fun (_clearme0:connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m))) => (((((((connectives.match_Or_prop) (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m))) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m))) (connectives.ex (nat.nat) (fun (a0:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a0 n) (nat.times b0 m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times a0 n)) (gcd_aux m n m)))))) (fun (H:logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m)) => (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b0 m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times x n)) (gcd_aux m n m))))) (b)) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times x m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times b n)) (gcd_aux m n m)))) (a)) ((((connectives.or_intror) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m))) (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (nat.times m a)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times b n)) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times m a) __) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux m n m)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (gcd_aux m n m))) (((logic.refl) (nat.nat)) (gcd_aux m n m))) (nat.minus (nat.times m a) (nat.times n b))) (((((((logic.rewrite_l) (nat.nat)) (nat.times b n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times m a) __) (gcd_aux m n m))) (((((((logic.rewrite_l) (nat.nat)) (nat.times a m)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times b n)) (gcd_aux m n m))) (H)) (nat.times m a)) (((nat.commutative_times) (a)) (m)))) (nat.times n b)) (((nat.commutative_times) (b)) (n))))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))) (nat.times a m)) (((nat.commutative_times) (a)) (m)))))))) (fun (H:logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m)) => (((((connectives.ex_intro) (nat.nat)) (fun (y:nat.nat) => connectives.ex (nat.nat) (fun (b0:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times y n) (nat.times b0 m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times b0 m) (nat.times y n)) (gcd_aux m n m))))) (b)) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times x m)) (gcd_aux m n m)) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times b n)) (gcd_aux m n m)))) (a)) ((((connectives.or_introl) (logic.eq (nat.nat) (nat.minus (nat.times b n) (nat.times a m)) (gcd_aux m n m))) (logic.eq (nat.nat) (nat.minus (nat.times a m) (nat.times b n)) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n b)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times a m)) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (nat.times m a)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times n b) __) (gcd_aux m n m))) (((((((logic.rewrite_r) (nat.nat)) (gcd_aux m n m)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (gcd_aux m n m))) (((logic.refl) (nat.nat)) (gcd_aux m n m))) (nat.minus (nat.times n b) (nat.times m a))) (((((((logic.rewrite_l) (nat.nat)) (nat.times a m)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus (nat.times n b) __) (gcd_aux m n m))) (((((((logic.rewrite_l) (nat.nat)) (nat.times b n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.minus __ (nat.times a m)) (gcd_aux m n m))) (H)) (nat.times n b)) (((nat.commutative_times) (b)) (n)))) (nat.times m a)) (((nat.commutative_times) (a)) (m))))) (nat.times a m)) (((nat.commutative_times) (a)) (m)))) (nat.times b n)) (((nat.commutative_times) (b)) (n)))))))) (_clearme0)))) (_clearme)))) (((((((eq_minus_gcd_aux) (m)) (n)) (m)) (posm)) ((((((nat.transitive_le) (m)) (nat.S m)) (n)) ((nat.le_n_Sn) (m))) ((((nat.not_le_to_lt) (n)) (m)) (nlenm)))) ((nat.le_n) (m)))))))))) (fun (eqm0:logic.eq (nat.nat) nat.O m) => (((((((logic.eq_ind_r) (nat.nat)) (m)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd n m)))))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times x n)) (gcd n m))))) (nat.S nat.O)) (((((connectives.ex_intro) (nat.nat)) (fun (y:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times y m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times y m) (nat.times (nat.S nat.O) n)) (gcd n m)))) (nat.O)) ((((connectives.or_introl) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times nat.O m)) (gcd n m))) (logic.eq (nat.nat) (nat.minus (nat.times nat.O m) (nat.times (nat.S nat.O) n)) (gcd n m))) (((((logic.eq_coerc) (logic.eq (nat.nat) n (nat.minus n nat.O))) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times nat.O m)) (gcd n m))) ((nat.minus_n_O) (n))) (((((((logic.rewrite_r) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n (nat.minus n __)) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n __) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) n) (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S __) n) (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n (nat.S m))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus n (nat.times n m))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (nat.times m n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus (nat.plus n __) (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus (nat.plus n __) (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (nat.plus m n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O m)) (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus n (nat.times __ m)) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) (nat.minus n __) (gcd n m)))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) __ (gcd n m)))) (((((((logic.rewrite_r) (nat.nat)) (gcd m n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) n __))) (((((((logic.rewrite_r) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) n n) (logic.eq (nat.nat) n __))) (((logic.refl) (Prop)) (logic.eq (nat.nat) n n))) (gcd m n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd __ n) n)) ((gcd_O_l) (n))) (m)) (eqm0)))) (gcd n m)) (((commutative_gcd) (n)) (m)))) (nat.minus n m)) ((((((let_clause_1549) (m)) (n)) (posn)) (eqm0)) (n)))) (nat.times m m)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.times m __))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.times m nat.O))) ((nat.times_n_O) (m))) (m)) (eqm0))) (m)) (eqm0)))) (nat.O)) (eqm0))) (nat.plus m n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) n (nat.plus __ n))) ((nat.plus_O_n) (n))) (m)) (eqm0)))) (nat.plus n m)) (((nat.commutative_plus) (n)) (m)))) (nat.times m n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.times __ n))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.times nat.O n))) ((nat.times_O_n) (n))) (m)) (eqm0))) (m)) (eqm0)))) (nat.times n m)) (((nat.commutative_times) (n)) (m)))) (nat.times n (nat.S m))) (((nat.times_n_Sm) (n)) (m)))) (nat.times (nat.S m) n)) (((nat.commutative_times) (nat.S m)) (n)))) (nat.O)) (eqm0))) (nat.minus n m)) ((((((let_clause_1549) (m)) (n)) (posn)) (eqm0)) (n)))) (nat.O)) (eqm0))))))) (nat.O)) (eqm0)))) ((((nat.le_to_or_lt_eq) (nat.O)) (m)) ((nat.le_O_n) (m)))))) (fun (eqn0:logic.eq (nat.nat) nat.O n) => (((((((logic.eq_ind_r) (nat.nat)) (n)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (a:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times a n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times a n)) (gcd n m)))))) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.ex (nat.nat) (fun (b:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times x n) (nat.times b m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times b m) (nat.times x n)) (gcd n m))))) (nat.O)) (((((connectives.ex_intro) (nat.nat)) (fun (x:nat.nat) => connectives.Or (logic.eq (nat.nat) (nat.minus (nat.times nat.O n) (nat.times x m)) (gcd n m)) (logic.eq (nat.nat) (nat.minus (nat.times x m) (nat.times nat.O n)) (gcd n m)))) (nat.S nat.O)) ((((connectives.or_intror) (logic.eq (nat.nat) (nat.minus (nat.times nat.O n) (nat.times (nat.S nat.O) m)) (gcd n m))) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) m) (nat.times nat.O n)) (gcd n m))) (((((logic.eq_coerc) (logic.eq (nat.nat) m (nat.minus m nat.O))) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) m) (nat.times nat.O n)) (gcd n m))) ((nat.minus_n_O) (m))) (((((((logic.rewrite_r) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m (nat.minus m nat.O)) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) m) (nat.times nat.O n)) __))) (((((((logic.rewrite_r) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m (nat.minus m __)) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) m) (nat.times nat.O n)) m))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m __) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S nat.O) m) (nat.times nat.O n)) m))) (((((((logic.rewrite_r) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus (nat.times (nat.S __) m) (nat.times nat.O n)) m))) (((((((logic.rewrite_r) (nat.nat)) (nat.times m (nat.S n))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O n)) m))) (((((((logic.rewrite_l) (nat.nat)) (nat.plus m (nat.times m n))) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O n)) m))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus (nat.plus m __) (nat.times nat.O n)) m))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus __ (nat.times nat.O n)) m))) (((((((logic.rewrite_r) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus m (nat.times __ n)) m))) (((((((logic.rewrite_l) (nat.nat)) (n)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) (nat.minus m __) m))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (Prop) (logic.eq (nat.nat) m m) (logic.eq (nat.nat) __ m))) (((logic.refl) (Prop)) (logic.eq (nat.nat) m m))) (nat.minus m n)) (((((let_clause_15491) (m)) (n)) (eqn0)) (m)))) (nat.times n n)) (((((let_clause_1551) (m)) (n)) (eqn0)) (n)))) (nat.O)) (eqn0))) (nat.plus m n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.plus m __))) ((nat.plus_n_O) (m))) (n)) (eqn0)))) (nat.times m n)) (((((let_clause_1551) (m)) (n)) (eqn0)) (m)))) (nat.times m (nat.S n))) (((nat.times_n_Sm) (m)) (n)))) (nat.times (nat.S n) m)) (((nat.commutative_times) (nat.S n)) (m)))) (nat.O)) (eqn0))) (nat.minus m n)) (((((let_clause_15491) (m)) (n)) (eqn0)) (m)))) (nat.O)) (eqn0))) (gcd n m)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (gcd __ m) m)) ((gcd_O_l) (m))) (n)) (eqn0)))))))) (nat.O)) (eqn0)))) ((((nat.le_to_or_lt_eq) (nat.O)) (n)) ((nat.le_O_n) (n))).
